'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var documenter = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(options) {
    var rv;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            options = _.defaults({}, options, {
              referenceUrl: 'https://docs.taskcluster.net/reference/',
              aws: null,
              credentials: undefined,
              project: null,
              tier: null,
              schemas: {},
              menuIndex: 10,
              readme: path.join(rootdir.get(), 'README.md'),
              docsFolder: path.join(rootdir.get(), '/docs'),
              bucket: 'taskcluster-raw-docs',
              references: [],
              publish: process.env.NODE_ENV == 'production'
            });

            rv = new Documenter(options);

            if (!options.publish) {
              _context.next = 5;
              break;
            }

            _context.next = 5;
            return rv.publish();

          case 5:
            return _context.abrupt('return', rv);

          case 6:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function documenter(_x) {
    return _ref.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var tar = require('tar-stream');
var _ = require('lodash');
var assert = require('assert');
var fs = require('mz/fs');
var path = require('path');
var recursiveReadSync = require('recursive-readdir-sync');
var zlib = require('zlib');
var rootdir = require('app-root-dir');
var aws = require('aws-sdk');

var client = require('taskcluster-client');
var S3UploadStream = require('s3-upload-stream');
var debug = require('debug')('taskcluster-lib-docs');
var util = require('util');
var mkdirp = util.promisify(require('mkdirp'));

module.exports = documenter;

var TIERS = ['core', 'platform', 'integrations', 'operations', 'libraries', 'workers'];

var Documenter = function () {
  function Documenter(options) {
    (0, _classCallCheck3.default)(this, Documenter);

    assert(options.schemas, 'options.schemas must be given');
    assert(options.tier, 'options.tier must be given');
    assert(TIERS.indexOf(options.tier) !== -1, 'options.tier must be one of ' + TIERS.join(', '));

    if (!options.project) {
      var pack = require(path.join(rootdir.get(), 'package.json'));
      options.project = pack.name;
    }
    this.options = options;
  }

  /**
   * Get the URL for documentation for this service; used in error messages.
   */


  (0, _createClass3.default)(Documenter, [{
    key: '_tarballStream',


    /**
     * Generate a stream containing a tarball with all of the associated metadata.
     * This is mostly to support the "old way", and when nothing uses the old way
     * anymore this can be adapted to write data directly to DOCS_OUTPUT_DIR.
     *
     * Note that this is a zlib-compressed tarball.
     */
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var _this = this;

        var headers, tarball, metadata;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                headers = function headers(name, dir) {
                  return { name: path.join(dir || '', name) };
                };

                tarball = tar.pack();
                metadata = {
                  version: 1,
                  project: this.options.project,
                  tier: this.options.tier,
                  menuIndex: this.options.menuIndex
                };


                tarball.entry(headers('metadata.json'), (0, _stringify2.default)(metadata, null, 2));

                _.forEach(this.options.schemas, function (schema, name) {
                  return tarball.entry(headers(name, 'schemas'), schema);
                });

                _.forEach(this.options.references, function (reference) {
                  return tarball.entry(headers(reference.name + '.json', 'references'), (0, _stringify2.default)(reference.reference, null, 2));
                });

                _context3.prev = 6;
                _context3.t0 = tarball;
                _context3.t1 = headers('README.md');
                _context3.next = 11;
                return fs.readFile(this.options.readme);

              case 11:
                _context3.t2 = _context3.sent;

                _context3.t0.entry.call(_context3.t0, _context3.t1, _context3.t2);

                _context3.next = 20;
                break;

              case 15:
                _context3.prev = 15;
                _context3.t3 = _context3['catch'](6);

                if (!(_context3.t3.code !== 'ENOENT')) {
                  _context3.next = 19;
                  break;
                }

                throw _context3.t3;

              case 19:
                debug('README.md does not exist. Continuing.');

              case 20:
                _context3.prev = 20;
                _context3.next = 23;
                return _promise2.default.all(recursiveReadSync(this.options.docsFolder).map(function () {
                  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(file) {
                    var relativePath;
                    return _regenerator2.default.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            relativePath = path.relative(_this.options.docsFolder, file);
                            _context2.t0 = tarball;
                            _context2.t1 = headers(relativePath, 'docs');
                            _context2.next = 5;
                            return fs.readFile(file, { encoding: 'utf8' });

                          case 5:
                            _context2.t2 = _context2.sent;

                            _context2.t0.entry.call(_context2.t0, _context2.t1, _context2.t2);

                          case 7:
                          case 'end':
                            return _context2.stop();
                        }
                      }
                    }, _callee2, _this);
                  }));

                  return function (_x2) {
                    return _ref3.apply(this, arguments);
                  };
                }()));

              case 23:
                _context3.next = 30;
                break;

              case 25:
                _context3.prev = 25;
                _context3.t4 = _context3['catch'](20);

                if (!(_context3.t4.code !== 'ENOENT')) {
                  _context3.next = 29;
                  break;
                }

                throw _context3.t4;

              case 29:
                debug('Docs folder does not exist. Continuing.');

              case 30:

                tarball.finalize();
                return _context3.abrupt('return', tarball.pipe(zlib.createGzip()));

              case 32:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this, [[6, 15], [20, 25]]);
      }));

      function _tarballStream() {
        return _ref2.apply(this, arguments);
      }

      return _tarballStream;
    }()

    /**
     * Write the tarball to a directory (the new way)
     */

  }, {
    key: 'write',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(_ref5) {
        var _this2 = this;

        var docsDir = _ref5.docsDir;
        var extract;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (docsDir) {
                  _context4.next = 4;
                  break;
                }

                throw new Error('docsDir is not set');

              case 4:
                if (!fs.existsSync(docsDir)) {
                  _context4.next = 6;
                  break;
                }

                throw new Error('docsDir ' + docsDir + ' already exists');

              case 6:

                // For the moment, this untar's the tarball created elsewhere in this file;
                // when the "old way' is no longer used, this should be refactored to just
                // write the files to the directory directly.
                extract = tar.extract();
                _context4.next = 9;
                return new _promise2.default(function (resolve, reject) {
                  extract.on('entry', function (header, stream, next) {
                    // NOTE: we ignore permissions, ownership, etc..
                    var pathname = path.join(docsDir, header.name);
                    mkdirp(path.dirname(pathname)).then(function () {
                      stream.once('end', next);
                      stream.once('error', reject);
                      stream.pipe(fs.createWriteStream(pathname));
                    }).catch(reject);
                  });

                  extract.on('finish', resolve);
                  extract.on('error', reject);

                  _this2._tarballStream().then(function (tbStream) {
                    return tbStream.pipe(zlib.Unzip()).pipe(extract);
                  }).catch(reject);
                });

              case 9:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function write(_x3) {
        return _ref4.apply(this, arguments);
      }

      return write;
    }()

    /**
     * Publish the tarball to S3 (the old way).
     *
     * This is called automatically if options.publish is true.
     */

  }, {
    key: 'publish',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        var gz, creds, auth, s3, s3Stream, upload, uploadPromise;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this._tarballStream();

              case 2:
                gz = _context5.sent;
                creds = this.options.aws;

                if (creds) {
                  _context5.next = 9;
                  break;
                }

                auth = new client.Auth({
                  credentials: this.options.credentials,
                  baseUrl: this.options.authBaseUrl
                });
                _context5.next = 8;
                return auth.awsS3Credentials('read-write', this.options.bucket, this.options.project + '/');

              case 8:
                creds = _context5.sent;

              case 9:
                s3 = new aws.S3(creds.credentials);
                s3Stream = new (this.options.S3UploadStream || S3UploadStream)(s3);
                upload = s3Stream.upload({
                  Bucket: this.options.bucket,
                  Key: this.options.project + '/latest.tar.gz'
                });

                // handle progress

                upload.on('part', function (details) {
                  debug(details);
                });

                uploadPromise = new _promise2.default(function (resolve, reject) {
                  // handle upload completion
                  upload.on('uploaded', function (details) {
                    debug(details);
                    resolve(details);
                  });

                  // handle errors
                  upload.on('error', function (error) {
                    console.log(error.stack);
                    reject(error);
                  });
                });

                // pipe the incoming filestream through compression and up to s3

                gz.pipe(upload);
                _context5.next = 17;
                return uploadPromise;

              case 17:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function publish() {
        return _ref6.apply(this, arguments);
      }

      return publish;
    }()
  }, {
    key: 'documentationUrl',
    get: function get() {
      return this.options.referenceUrl + this.options.tier + '/' + this.options.project;
    }
  }]);
  return Documenter;
}();
//# sourceMappingURL=documenter.js.map
