'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var downloader = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(options) {
    var auth, s3, creds, readStream;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            options = _.defaults({}, options, {
              credentials: {},
              bucket: 'taskcluster-raw-docs',
              project: null
            });

            auth = new client.Auth({
              credentials: options.credentials
            });
            s3 = void 0;

            if (!options._s3) {
              _context.next = 7;
              break;
            }

            s3 = options._s3;
            _context.next = 11;
            break;

          case 7:
            _context.next = 9;
            return auth.awsS3Credentials('read-only', options.bucket, options.project + '/');

          case 9:
            creds = _context.sent;

            s3 = new aws.S3(creds.credentials);

          case 11:
            readStream = s3.getObject({
              Bucket: options.bucket,
              Key: options.project + '/latest.tar.gz'
            }).createReadStream();
            return _context.abrupt('return', readStream.pipe(zlib.Unzip()));

          case 13:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function downloader(_x) {
    return _ref.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _ = require('lodash');
var client = require('taskcluster-client');
var aws = require('aws-sdk');
var zlib = require('zlib');

module.exports = downloader;
//# sourceMappingURL=downloader.js.map
